# generated from rosidl_generator_py/resource/_idl.py.em
# with input from multisensor_calibration_interface:msg/CalibrationResult.idl
# generated code does not contain a copyright notice

# This is being done at the module level and not on the instance level to avoid looking
# for the same variable multiple times on each instance. This variable is not supposed to
# change during runtime so it makes sense to only look for it once.
from os import getenv

ros_python_check_fields = getenv('ROS_PYTHON_CHECK_FIELDS', default='')


# Import statements for member types

import builtins  # noqa: E402, I100

import rosidl_parser.definition  # noqa: E402, I100


class Metaclass_CalibrationResult(type):
    """Metaclass of message 'CalibrationResult'."""

    _CREATE_ROS_MESSAGE = None
    _CONVERT_FROM_PY = None
    _CONVERT_TO_PY = None
    _DESTROY_ROS_MESSAGE = None
    _TYPE_SUPPORT = None

    __constants = {
    }

    @classmethod
    def __import_type_support__(cls):
        try:
            from rosidl_generator_py import import_type_support
            module = import_type_support('multisensor_calibration_interface')
        except ImportError:
            import logging
            import traceback
            logger = logging.getLogger(
                'multisensor_calibration_interface.msg.CalibrationResult')
            logger.debug(
                'Failed to import needed modules for type support:\n' +
                traceback.format_exc())
        else:
            cls._CREATE_ROS_MESSAGE = module.create_ros_message_msg__msg__calibration_result
            cls._CONVERT_FROM_PY = module.convert_from_py_msg__msg__calibration_result
            cls._CONVERT_TO_PY = module.convert_to_py_msg__msg__calibration_result
            cls._TYPE_SUPPORT = module.type_support_msg__msg__calibration_result
            cls._DESTROY_ROS_MESSAGE = module.destroy_ros_message_msg__msg__calibration_result

            from geometry_msgs.msg import Transform
            if Transform.__class__._TYPE_SUPPORT is None:
                Transform.__class__.__import_type_support__()

    @classmethod
    def __prepare__(cls, name, bases, **kwargs):
        # list constant names here so that they appear in the help text of
        # the message class under "Data and other attributes defined here:"
        # as well as populate each message instance
        return {
        }


class CalibrationResult(metaclass=Metaclass_CalibrationResult):
    """Message class 'CalibrationResult'."""

    __slots__ = [
        '_is_successful',
        '_src_frame_id',
        '_ref_frame_id',
        '_base_frame_id',
        '_sensor_extrinsics',
        '_check_fields',
    ]

    _fields_and_field_types = {
        'is_successful': 'boolean',
        'src_frame_id': 'string',
        'ref_frame_id': 'string',
        'base_frame_id': 'string',
        'sensor_extrinsics': 'geometry_msgs/Transform',
    }

    # This attribute is used to store an rosidl_parser.definition variable
    # related to the data type of each of the components the message.
    SLOT_TYPES = (
        rosidl_parser.definition.BasicType('boolean'),  # noqa: E501
        rosidl_parser.definition.UnboundedString(),  # noqa: E501
        rosidl_parser.definition.UnboundedString(),  # noqa: E501
        rosidl_parser.definition.UnboundedString(),  # noqa: E501
        rosidl_parser.definition.NamespacedType(['geometry_msgs', 'msg'], 'Transform'),  # noqa: E501
    )

    def __init__(self, **kwargs):
        if 'check_fields' in kwargs:
            self._check_fields = kwargs['check_fields']
        else:
            self._check_fields = ros_python_check_fields == '1'
        if self._check_fields:
            assert all('_' + key in self.__slots__ for key in kwargs.keys()), \
                'Invalid arguments passed to constructor: %s' % \
                ', '.join(sorted(k for k in kwargs.keys() if '_' + k not in self.__slots__))
        self.is_successful = kwargs.get('is_successful', bool())
        self.src_frame_id = kwargs.get('src_frame_id', str())
        self.ref_frame_id = kwargs.get('ref_frame_id', str())
        self.base_frame_id = kwargs.get('base_frame_id', str())
        from geometry_msgs.msg import Transform
        self.sensor_extrinsics = kwargs.get('sensor_extrinsics', Transform())

    def __repr__(self):
        typename = self.__class__.__module__.split('.')
        typename.pop()
        typename.append(self.__class__.__name__)
        args = []
        for s, t in zip(self.get_fields_and_field_types().keys(), self.SLOT_TYPES):
            field = getattr(self, s)
            fieldstr = repr(field)
            # We use Python array type for fields that can be directly stored
            # in them, and "normal" sequences for everything else.  If it is
            # a type that we store in an array, strip off the 'array' portion.
            if (
                isinstance(t, rosidl_parser.definition.AbstractSequence) and
                isinstance(t.value_type, rosidl_parser.definition.BasicType) and
                t.value_type.typename in ['float', 'double', 'int8', 'uint8', 'int16', 'uint16', 'int32', 'uint32', 'int64', 'uint64']
            ):
                if len(field) == 0:
                    fieldstr = '[]'
                else:
                    if self._check_fields:
                        assert fieldstr.startswith('array(')
                    prefix = "array('X', "
                    suffix = ')'
                    fieldstr = fieldstr[len(prefix):-len(suffix)]
            args.append(s + '=' + fieldstr)
        return '%s(%s)' % ('.'.join(typename), ', '.join(args))

    def __eq__(self, other):
        if not isinstance(other, self.__class__):
            return False
        if self.is_successful != other.is_successful:
            return False
        if self.src_frame_id != other.src_frame_id:
            return False
        if self.ref_frame_id != other.ref_frame_id:
            return False
        if self.base_frame_id != other.base_frame_id:
            return False
        if self.sensor_extrinsics != other.sensor_extrinsics:
            return False
        return True

    @classmethod
    def get_fields_and_field_types(cls):
        from copy import copy
        return copy(cls._fields_and_field_types)

    @builtins.property
    def is_successful(self):
        """Message field 'is_successful'."""
        return self._is_successful

    @is_successful.setter
    def is_successful(self, value):
        if self._check_fields:
            assert \
                isinstance(value, bool), \
                "The 'is_successful' field must be of type 'bool'"
        self._is_successful = value

    @builtins.property
    def src_frame_id(self):
        """Message field 'src_frame_id'."""
        return self._src_frame_id

    @src_frame_id.setter
    def src_frame_id(self, value):
        if self._check_fields:
            assert \
                isinstance(value, str), \
                "The 'src_frame_id' field must be of type 'str'"
        self._src_frame_id = value

    @builtins.property
    def ref_frame_id(self):
        """Message field 'ref_frame_id'."""
        return self._ref_frame_id

    @ref_frame_id.setter
    def ref_frame_id(self, value):
        if self._check_fields:
            assert \
                isinstance(value, str), \
                "The 'ref_frame_id' field must be of type 'str'"
        self._ref_frame_id = value

    @builtins.property
    def base_frame_id(self):
        """Message field 'base_frame_id'."""
        return self._base_frame_id

    @base_frame_id.setter
    def base_frame_id(self, value):
        if self._check_fields:
            assert \
                isinstance(value, str), \
                "The 'base_frame_id' field must be of type 'str'"
        self._base_frame_id = value

    @builtins.property
    def sensor_extrinsics(self):
        """Message field 'sensor_extrinsics'."""
        return self._sensor_extrinsics

    @sensor_extrinsics.setter
    def sensor_extrinsics(self, value):
        if self._check_fields:
            from geometry_msgs.msg import Transform
            assert \
                isinstance(value, Transform), \
                "The 'sensor_extrinsics' field must be a sub message of type 'Transform'"
        self._sensor_extrinsics = value
